//tema_main.c

#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <pthread.h>
#include <sys/time.h>
#include "tema_main.h" 		//подключаем наш заголовочный файл 
#include "tema_socket.h"	//подключаем заголовочный файл для работы с сокетами

int	ipport;	//наш порт прослушивания

float	test;	//наш параметр тест типа float

int main(int argc, char **argv)
{
	int scnt = 1; //счётчик для анализа входных параметров
	int res = 1;
	//без параметров
	if(argc < 2)
	{
		printf("\nParametrs not defined!\r\n");
		printf("\"--help\" for information\n");
		return 1;
	}
	//
	while(scnt < argc)
	{
		//подсказка
		if(strcmp(argv[scnt], "--help") == 0)
		{
			printf(__help);
			return 0;
		}
		//размер стоп бита
                else if(strcmp(argv[scnt], "-p") == 0)
                {
                        scnt++;
                        if(!(scnt < argc))
                                return 2;
                        ipport = atoi(argv[scnt]);
                        if(ipport == 0)
				return 3;
		}
		else
			return 4;
		scnt++;
	}
	//открытие прослушивающего сокета - запуск сервера
	res = SocketStart();
	printf("---- opening tcp/ip  %u ----\r\n", ipport);
	if(res != 0)
	{
		printf("ERROR starting server\n");
		return 5;
	}
	//обнуляем test
	test	= 0.1;
	//наш цикл Main
	while(1)
	{
		//вставить вместо этого комментария какую-нибудь обработку - функцию
		MainWork();	//мы вставляем тестовую функцию
		usleep(50000);
	}
	//
	return 0;
}

//тестовый модуль
void	MainWork(void)
{
	pthread_mutex_lock(&ServerMutex);
	if(test < 999.999)
		test += 11.1;
	else
		test = 0.0;
	(*(float*)(&wbufto[0])) = test;
	pthread_mutex_unlock(&ServerMutex);
}
